#!/usr/bin/perl -w
use strict;

use Gtk2 '-init';
use constant TRUE => 1;
use constant FALSE => 0;

my $radios = 1;
my $checked = 1;

my $window = Gtk2::Window->new;
$window->set_title ('Testing a Button');
$window->signal_connect (delete_event => sub { Gtk2->main_quit; TRUE });

my $button = Gtk2::Button->new ('_Press Me');
$button->signal_connect(clicked => sub { message() });

$window->add ($button);
$window->show_all;
Gtk2->main;

sub message
{
	my $dialog = Gtk2::Dialog->new ('Preferences', $window,
		'destroy-with-parent', 'gtk-cancel' => 'cancel',
		'gtk-save' => 'accept');

	my $main_hbox = Gtk2::HBox->new (FALSE,10);
	my $left_vbox = Gtk2::VBox->new (TRUE,5);
	my $right_vbox = Gtk2::VBox->new (TRUE,5);

	$main_hbox->pack_start ($left_vbox,TRUE,FALSE,0);
	$main_hbox->pack_start (Gtk2::VSeparator->new,FALSE,FALSE,0);
	$main_hbox->pack_start ($right_vbox,TRUE,FALSE,0);
	$dialog->vbox->pack_start ($main_hbox,FALSE,FALSE,0);

	# Entries {{{1
	my $dir_table = Gtk2::Table->new (1,3,FALSE);
	$dir_table->set_col_spacings (5);
	my $dir_entry = Gtk2::Entry->new;
	my $dir_entry_label = Gtk2::Label->new_with_mnemonic ("_Directory");
	$dir_entry_label->set_alignment (1,0.5);
	$dir_entry_label->set_mnemonic_widget ($dir_entry);
	$dir_entry->set_text ("/");
	my $dir_open_button = Gtk2::Button->new;
	$dir_open_button->add (Gtk2::Image->new_from_icon_name ('gtk-open',
			'small-toolbar'));
	$dir_open_button->signal_connect (clicked => sub {
			if (my $hold = choose_folder ($dir_entry->get_text)) {
				$dir_entry->set_text ($hold);
			}
		});
	$dir_table->attach_defaults ($dir_entry_label,0,1,0,1);
	$dir_table->attach_defaults ($dir_entry,1,2,0,1);
	$dir_table->attach_defaults ($dir_open_button,2,3,0,1);

	my $name_table = Gtk2::Table->new (1,2,FALSE);
	$name_table->set_col_spacings (5);
	my $name_entry = Gtk2::Entry->new;
	my $name_entry_label = Gtk2::Label->new_with_mnemonic ("_Name");
	$name_entry_label->set_alignment (1,0.5);
	$name_entry_label->set_mnemonic_widget ($name_entry);
	$name_entry->set_text ("Name Goes Here");
	$name_table->attach_defaults ($name_entry_label,0,1,0,1);
	$name_table->attach_defaults ($name_entry,1,2,0,1);
	#}}}1

	# Radio Buttons {{{1
	my $radio1 = Gtk2::RadioButton->new (undef,'First');
	my @r_group = $radio1->get_group;
	my $radio2 = Gtk2::RadioButton->new (@r_group,'Second');
	@r_group = $radio1->get_group;
	my $radio3 = Gtk2::RadioButton->new (@r_group,'Third');
	$radio1->signal_connect (clicked => sub {
			($radio1->get_active) and ($radios = 1); });
	$radio2->signal_connect (clicked => sub {
			($radio2->get_active) and ($radios = 2); });
	$radio3->signal_connect (clicked => sub {
			($radio3->get_active) and ($radios = 3); });
	# Initial Values:
	if ($radios == 1) { $radio1->set_active (TRUE); }
	elsif ($radios == 2) { $radio2->set_active (TRUE); }
	else { $radio3->set_active (TRUE); }

	my $radio_table = Gtk2::Table->new (1,3,FALSE);
	$radio_table->set_col_spacings (5);
	$radio_table->attach_defaults ($radio1,0,1,0,1);
	$radio_table->attach_defaults ($radio2,1,2,0,1);
	$radio_table->attach_defaults ($radio3,2,3,0,1);
	#}}}1

	# Checkbox {{{1
	my $checkbox = Gtk2::CheckButton->new ("_Radio Buttons");
	$checkbox->signal_connect (clicked => sub {
			if ($checkbox->get_active) {
				$checked = 1;
				$radio1->set_sensitive (TRUE);
				$radio2->set_sensitive (TRUE);
				$radio3->set_sensitive (TRUE);
			} else {
				$checked = 0;
				$radio1->set_sensitive (FALSE);
				$radio2->set_sensitive (FALSE);
				$radio3->set_sensitive (FALSE);
			} });
	if ($checked) { $checkbox->set_active (TRUE); }
	else { $checkbox->set_active (FALSE); }

	# Sensitivity on the Radios
	if (!$checked) {
		$radio1->set_sensitive(FALSE);
		$radio2->set_sensitive(FALSE);
		$radio3->set_sensitive (FALSE);
	}
	#}}}1

	$left_vbox->pack_start ($dir_table,FALSE,FALSE,0);
	$left_vbox->pack_start ($name_table,FALSE,FALSE,0);
	$right_vbox->pack_start ($radio_table,FALSE,FALSE,0);
	$right_vbox->pack_start ($checkbox,FALSE,FALSE,0);

	$dialog->signal_connect (response => sub {$_[0]->destroy});
	$dialog->show_all;

}

sub choose_folder
{
	my $start = shift;

	my $file_dialog = Gtk2::FileChooserDialog->new ('Choose a Starting Folder',
		$window, 'select-folder',
		'gtk-cancel'	=> 'cancel',
		'gtk-ok'	=> 'ok');
	$file_dialog->set_select_multiple (FALSE);
	if (-e $start && -d $start) {
		$file_dialog->set_current_folder ($start);
	}

	my $response = $file_dialog->run;
	my $folder = $file_dialog->get_filename;
	$file_dialog->destroy;

	if ($response eq 'cancel') {
		return FALSE;
	} else {
		return $folder;
	}
}
