#!/usr/bin/perl -w
use strict;

use Gtk2 '-init';
use constant TRUE => 1;
use constant FALSE => 0;

my $radios = 1;
my $checked = 1;

my $window = Gtk2::Window->new;
$window->set_title ('Testing a Button');
$window->signal_connect (delete_event => sub { Gtk2->main_quit; TRUE });

my $button = Gtk2::Button->new ('_Press Me');
$button->signal_connect(clicked => sub { message() });

$window->add ($button);
$window->show_all;
Gtk2->main;

sub message
{
	# Prep the dialog box
	my $run_dialog = Gtk2::Dialog->new ('Running...', $window,
		'destroy-with-parent', 'gtk-cancel' => 'cancel');
	$run_dialog->set_default_response ('cancel');
	$run_dialog->set_default_size(450,100);
	$run_dialog->set_keep_above (TRUE);
	$run_dialog->set_resizable (TRUE);
	my $run_vbox = Gtk2::VBox->new (FALSE,10);

	my $progressbar = Gtk2::ProgressBar->new;
	$progressbar->set_orientation ('left-to-right');

	$run_dialog->vbox->pack_start ($run_vbox,FALSE,FALSE,0);
	$run_vbox->pack_start ($progressbar,FALSE,FALSE,0);

	my $run = 1;
	$run_dialog->signal_connect (response => sub {
			$run = 0;
			$progressbar->set_text ("Dieing soon..");
		});

	$run_dialog->show_all;
	while (Gtk2->events_pending) {
		Gtk2->main_iteration;
	}
	Gtk2::Gdk->flush;

	my $total_ops = 10;
	my $increment = 1 / $total_ops;
	my $fraction = $progressbar->get_fraction;
	for (my $x=0; $x < $total_ops; $x++) {
		if (!$run) {
			$run_dialog->destroy;
			return;
		}
		if ($fraction <= 1.0) {
			$progressbar->set_fraction($fraction);
			$fraction += $increment;
		}

		while (Gtk2->events_pending) {
			Gtk2->main_iteration;
		}
		Gtk2::Gdk->flush;

		sleep 2;
	}
}
